Bug 41775 - Zip version needed to extract not correct in System.IO.Compression
Summary: Zip version needed to extract not correct in System.IO.Compression
Status: VERIFIED FIXED
Alias: None
Product: Class Libraries
Classification: Mono
Component: General (show other bugs)
Version: 4.4.0 (C7)
Hardware: PC Mac OS
: --- normal
Target Milestone: Untriaged
Assignee: João Matos
URL:
Depends on:
Blocks:
 
Reported: 2016-06-13 20:19 UTC by Bill Holmes
Modified: 2016-06-20 06:15 UTC (History)
2 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
files to show the problem (1.01 KB, application/zip)
2016-06-13 20:19 UTC, Bill Holmes
Details


Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
VERIFIED FIXED

Description Bill Holmes 2016-06-13 20:19:38 UTC
Created attachment 16305 [details]
files to show the problem

Found this with NuGet 3.4.4.  NuGet 3.4.4 packages that are created with Mono will cause errors when added to VS.

I have attached a simple case to reproduce the issue.  To run simply `sh run.sh`.

This script downloads Nuget 3.4.4 and runs a pack command.  Then I run zip with a fix argument and get a few warnings.  These warnings appear to be linked to what is causing the problem in VS.

Warning example...
zip warning: Local Version Needed To Extract does not match CD

I believe this is caused by this commit ot mono.
https://github.com/mono/mono/commit/77b034cbe78bfccfe4c1995152bd5562a1d69ef5

This commit attempted to change the 'version needed to extract' bytes.  For ZipWriter that appears to be correct.  However for ZipCentralDirectoryEntry I believe the 'version made by' bytes were changed.

The patch in the gist below fixes the issue for us.  The zip test referenced above works with the change as well as VS can not read the nupkg.

https://gist.github.com/bholmes/09c9a4e5a5c9a2f14831a7b2b7ce89aa